import {ApplicationState, ContentNegotiation, Resource} from '../common';
import {BaseDataSource} from '../common/data-source';

export interface BackendState {
	app: ApplicationState;
	dataSource: (resource: Resource) => BaseDataSource;
	cn: ContentNegotiation;
	showTotalItemCountOnGetCollection: boolean;
	throws404OnDeletingNotFound: boolean;
	checksSerializersOnDelete: boolean;
	showTotalItemCountOnCreateItem: boolean;
}

export interface RequestContext {}

export type RequestDecorator = (req: RequestContext) => RequestContext | Promise<RequestContext>;

export type ParamRequestDecorator<Params extends Array<unknown> = []> = (...args: Params) => RequestDecorator;
