import {BaseDataSource} from '../common/data-source';

export interface DataSource<T = object, Q = object> extends BaseDataSource {
	initialize(): Promise<unknown>;
	getTotalCount?(query?: Q): Promise<number>;
	getMultiple(query?: Q): Promise<T[]>;
	getById(id: string): Promise<T | null>;
	getSingle?(query?: Q): Promise<T | null>;
	create(data: T): Promise<T>;
	delete(id: string): Promise<unknown>;
	emplace(id: string, data: T): Promise<[T, boolean]>;
	patch(id: string, data: Partial<T>): Promise<T | null>;
}
